import processing.serial.*;

int filter_length = 10;
int filter_index;
int filter_buffer[];
int lf = 10;
int prevY;
Serial myPort;


void setup() {

  printArray(Serial.list());
  //TODO: Choose the appropriate port
  String portName = "COM6"; //<- CHANGE THIS TO YOUR PORT NAME
  // Open the port you are using at the rate you want:
  myPort = new Serial(this, portName, 9600);
  
  size(1000, 1100);
  drawGrid();
  frameRate(200);
}

void draw() {
  if(myPort.available()>0) {
    byte[] inBuffer = myPort.readBytesUntil(lf);
    if(inBuffer != null) {
      stroke(255, 0, 0);
      
      //read one value form the device
      String temp = new String(shorten(inBuffer));
      int val = int(temp);

      //plot it
      //TODO: change code around here to incorporate the new value
      line(frameCount-1, height-prevY, frameCount, height - val);
      if(frameCount >= width){
        frameCount=0;
        drawGrid();
      }
      prevY = val;
    }
  }
}


void drawGrid() {
  background(255);
  for (int i = 0; i <= width; i += 50) {
    fill(0);
    text(i/2, i-10, height-15);
    stroke(0);
    line(i, height, i, 0);
  }
  for (int j = 0; j < height; j += 50) {
    fill(0);
    text(height-j, 0, j);
    stroke(0);
    line(0, j, width, j);
  }
}